/*
   memory.cpp - version 1.0, 2002

   cMemory is a class for storing computed values 
   identified by integers.

   Copyright (c) 2001-2002 Andreas Jnsson

   This software is provided 'as-is', without any form of
   warranty. In no case will the author be held responsible
   for any damage caused by its use.

   Permission is granted to anyone to use the software for
   for any purpose, including commercial. It is also allowed
   to modify the software and redistribute it free of charge.
   The permission is granted with the following restrictions:

   1. The origin of the software may not be misrepresented.
      It must be plainly understandable who is the author of
      the original software.
   2. Altered versions must not be misrepresented as the
      original software, i.e. must be plainly marked as
      altered.
   3. This notice may not be removed or altered from any
      distribution of the software, altered or not.

   Andreas Jnsson
   andreas@angelcode.com
*/

#include "memory.h"
#include "interpreter.h"

cMemory::cMemory()
{
}

double cMemory::Store(int id, double value)
{
	cMapIntToDouble::iterator it;
	it = memory.find(id);
	if( it == memory.end() )
	{
		memory.insert(cMapIntToDouble::value_type(id, value));
	}
	else
	{
		(*it).second = value;
	}

	return value;
}

double cMemory::Recall(int id)
{
	cMapIntToDouble::iterator it;
	it = memory.find(id);
	if( it == memory.end() )
	{
		cCalcException *e = new cCalcException("Memory slot is empty\n");
		throw e;
	}

	return (*it).second;
}

double cMemory::Clear(int id)
{
	cMapIntToDouble::iterator it;
	it = memory.find(id);
	if( it == memory.end() )
	{
		cCalcException *e = new cCalcException("Memory slot is empty\n");
		throw e;
	}

	double value = (*it).second;

	memory.erase(it);

	return value;
}